Opened 7 years ago

Closed 7 years ago

Last modified 7 years ago

#180 closed defect (invalid)

enabling SPDY+nginx 1.3.2 breaks gzip

Reported by: pgndev.pip.verisignlabs.com Owned by: somebody
Priority: major Milestone:
Component: nginx-core Version: 1.3.x
Keywords: Cc:
uname -a: Linux svr06.loc 3.1.10-1.13-desktop #1 SMP PREEMPT Tue Jun 12 13:11:31 UTC 2012 (44a489e) x86_64 x86_64 x86_64 GNU/Linux
nginx -V: nginx version: nginx/1.3.2 TLS SNI support enabled configure arguments: --with-debug --user=nobody --group=nobody --prefix=/usr/local --sbin-path=/usr/local/sbin/nginx --conf-path=/usr/local/etc/nginx/nginx.conf --pid-path=/var/run/nginx.pid --lock-path=/var/lock/nginx.lock --error-log-path=/var/log/nginx/error.log --http-log-path=/var/log/nginx/access.log --with-ipv6 --with-pcre=/usr/local/src/pcre --with-pcre-jit --with-cc=/usr/bin/gcc-4.7 --with-cpp=/usr/bin/cpp-4.7 --with-cc-opt='-fPIC -DPIC -D_GNU_SOURCE -fno-strict-aliasing -Wall' --with-ld-opt='-L/usr/local/ssl/lib64 -Wl,-rpath,/usr/local/ssl/lib64 -lssl -lcrypto -ldl -lz' --add-module=/usr/local/src/ngx_devel_kit --add-module=/usr/local/src/lua-nginx-module --with-md5-asm --with-sha1-asm --with-http_ssl_module

Description

nginx 1.3.2 + SPDY patch build

with SPDY disabled, response headers show backend's gzip compression headers

(1) nginx/1.3.2, SPDY <- OFF + Varnish3

	nginx vhost conf:
		listen      192.168.1.17:443;
		listen      [2001:453:3cd6:7b2::9]:443 ipv6only=on;

	Response Headers
		Accept-Ranges	bytes
		Age	5
		Cache-Control	public, max-age=300
==>		Content-Encoding	gzip
		Content-Language	en
		Content-Length	4560
		Content-Type	text/html; charset=utf-8
		Date	Tue, 26 Jun 2012 16:55:27 GMT
		Expires	Sun, 19 Nov 1978 05:00:00 GMT
		Last-Modified	Tue, 26 Jun 2012 16:55:18 GMT
		Link	<https://test.svr06.loc/>; rel="canonical"
==>		Server	nginx
		Vary	Accept-Encoding,User-Agent
		Via	1.1 varnish
		X-Cache-Hits	1
		X-Drupal-Cache	MISS
		X-Varnish	179527312 179527285
		X-Varnish-Cache	HIT
		x-ua-compatible	IE=Edge,chrome=1

	Request Headers
		Accept	text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8
==>		Accept-Encoding	gzip, deflate
		Accept-Language	en,en-us;q=0.5
		Connection	keep-alive
		Cookie	has_js=1
		DNT	1
		Host test.svr06.loc
		User-Agent	Mozilla/5.0 (X11; Linux x86_64; rv:13.0) Gecko/20100101 Firefox/13.0.1

with SPDY EN-abled, gzip response headers are missing

(2) nginx/1.3.2, SPDY <- ON + Varnish3

	nginx vhost conf:
		listen      192.168.1.17:443 ssl spdy;
		listen      [2001:453:3cd6:7b2::9]:443 ssl spdy ipv6only=on;

	Response Headers
		Age	26
		Cache-Control	public, max-age=300
		Content-Language	en
		Content-Type	text/html; charset=utf-8
		Date	Tue, 26 Jun 2012 16:51:22 GMT
		Expires	Sun, 19 Nov 1978 05:00:00 GMT
		Last-Modified	Tue, 26 Jun 2012 16:50:52 GMT
		Link	<https://test.svr06.loc/>; rel="canonical"
==>		Server	nginx
		Vary	Accept-Encoding,User-Agent
		Via	1.1 varnish
		X-Cache-Hits	1
		X-Drupal-Cache	MISS
==>		X-Firefox-Spdy	1
		X-Varnish	851454988 851454961
		X-Varnish-Cache	HIT
		x-ua-compatible	IE=Edge,chrome=1

	Request Headers
		Accept	text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8
==>		Accept-Encoding	gzip, deflate
		Accept-Language	en,en-us;q=0.5
		Connection	keep-alive
		Cookie	has_js=1
		DNT	1
		Host test.svr06.loc
		User-Agent	Mozilla/5.0 (X11; Linux x86_64; rv:13.0) Gecko/20100101 Firefox/13.0.1

Change History (4)

comment:1 follow-up: Changed 7 years ago by maxim

Hello,

what version of SPDY patch you use?

The issue you describe should be fixed in #40:

http://nginx.org/patches/spdy/CHANGES.txt

The latest one is #42:

http://nginx.org/patches/spdy/patch.spdy-42.txt

Could you please test it and report your results?

Thanks!

comment:2 Changed 7 years ago by mdounin

  • Resolution set to invalid
  • Status changed from new to closed

Guys, really, trac is a wrong place to discuss experimental patches. Please move to nginx-devel@ where patches were announced and feedback is expected.

comment:3 in reply to: ↑ 1 Changed 7 years ago by pgndev.pip.verisignlabs.com

what version of SPDY patch you use?

I DL'd and applied, http://nginx.org/patches/spdy/patch.spdy-42.txt

Could you please test it and report your results?

the results above represent that patch's use

Guys, really, trac is a wrong place to discuss experimental patches.
Please move to nginx-devel@ where patches were announced and feedback is expected.

I already had subscribed to the list.

I originally posted this issue to the list on:

On Sun, Jun 17, 2012 at 4:21 PM, <pgn...@…> wrote:

My webstack consists of

nginx/ssl --( proxy pass )-> varnish --( backend/reverse_proxy )-> apache/gzip

I've built nginx 131 with SPDY support on linux/64 w/ gcc4.7.

and 'bumped' it a day or so again.

Though I receive mail from the list, I've neither seen my messages post, nor received any response from the list, or list owner ...

If you'd like my continued help then please either re-open this bug, or assist in fixing the mailing list issue.

Note: See TracTickets for help on using tickets.